import { Component, OnInit, Inject, ViewChild } from '@angular/core';
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material';

import { DialogService, SnackBarService } from '@ucap-webmessenger/ui';

import {
  DetailResponse,
  DetailContent,
  MessageApiService
} from '@ucap-webmessenger/api-message';

import { LoginResponse } from '@ucap-webmessenger/protocol-authentication';
import { NGXLogger } from 'ngx-logger';
import { MessageStatusCode } from '@ucap-webmessenger/api';
import { WriteComponent as UCapMessageWriteComponent } from '@ucap-webmessenger/ui-message';

export interface MessageWriteDialogData {
  loginRes: LoginResponse;
  detail?: DetailResponse;
}

// tslint:disable-next-line: no-empty-interface
export interface MessageWriteDialogResult {}

export interface DownloadQueueForMessage extends DetailContent {
  downloadType: string;
}

@Component({
  selector: 'app-layout-messenger-message-write',
  templateUrl: './message-write.dialog.component.html',
  styleUrls: ['./message-write.dialog.component.scss']
})
export class MessageWriteDialogComponent implements OnInit {
  @ViewChild('messageWrite', { static: true })
  messageWrite: UCapMessageWriteComponent;

  constructor(
    public dialogRef: MatDialogRef<
      MessageWriteDialogData,
      MessageWriteDialogResult
    >,
    @Inject(MAT_DIALOG_DATA) public data: MessageWriteDialogData,
    private messageApiService: MessageApiService,
    private snackBarService: SnackBarService,
    private logger: NGXLogger,
    private dialogService: DialogService
  ) {}

  ngOnInit(): void {}

  getBtnValid() {
    return true;
  }

  onClickChoice(choice: boolean): void {
    this.dialogRef.close();
  }

  onClickTest() {
    this.messageWrite.printEditor();
  }
}
